/* qksort - sort array a (dimension n) using quicksort
 */
#include "local.h"
void qksort(a, n)
	int a[];
	int n;
	{
	iqksort(a, &a[n-1]);
	}
static void iqksort(lo, hi)
	int *lo, *hi;
	{
	int *mid = lo + (hi - lo) / 2;
	register int *i;
	register int *lastlo;
	int t;
	register int tmp;

	if (hi <= lo)
		return;
	SWAP(*lo, *mid, tmp);
	t = *lo;
	lastlo = lo;
	for (i = lo+1; i <= hi; ++i)
		{
		if (*i < t)
			{
			++lastlo;
			SWAP(*lastlo, *i, tmp);
			}
		}
	SWAP(*lo, *lastlo, tmp);
	iqksort(lo, lastlo - 1);
	iqksort(lastlo + 1, hi);
	}
